<app-loading *ngIf="isLoading"></app-loading>
<form [formGroup]="setOfIndicatorForm">
  <div nz-row [nzGutter]="[30, 10]">

    <div nz-col nzXs="24" nzLg="8">
      <mb-select [mbDataSelects]="listAssingType" mbKeyLabel="label" mbKeyValue="value" formControlName="assignedType"
        [mbDisable]="copy"
        [mbType]="isSubmitted && setOfIndicatorForm.controls['assignedType'].errors ? 'error' : 'default'"
        [mbShowError]="isSubmitted && setOfIndicatorForm.controls['assignedType'].errors !== null"
        [mbErrors]="setOfIndicatorForm.controls['assignedType'].errors" [mbErrorDefs]="[
        { errorName: 'required', errorDescription: 'Trường bắt buộc'}]"
        mbLabelText="Cấp giao <span class='label__required'>*</span>" mbPlaceholder="Cấp giao"
        (mbSelect)="onChangeAssignedType($event)"></mb-select>
    </div>

    <div nz-col nzXs="24" nzLg="8"
      [ngStyle]="setOfIndicatorForm.value['assignedType'] === 'HT' ? {'display': 'none'} : {}">
      <mb-select [mbDataSelects]="listPosType" mbKeyLabel="lable" mbKeyValue="value" formControlName="posType"
        [mbType]="isSubmitted && setOfIndicatorForm.controls['posType'].errors ? 'error' : 'default'"
        [mbShowError]="isSubmitted && setOfIndicatorForm.controls['posType'].errors !== null"
        [mbErrors]="setOfIndicatorForm.controls['posType'].errors" [mbErrorDefs]="[
        { errorName: 'required', errorDescription: 'Trường bắt buộc'}]"
        mbLabelText="Gán cho <span class='label__required'>*</span>" mbPlaceholder="Gán cho"
        (ngModelChange)="onChangePosType($event)">
      </mb-select>
    </div>

    <div nz-col nzXs="24" nzLg="8"
      [ngStyle]="(setOfIndicatorForm.value['assignedType'] === 'HT' || this.setOfIndicatorForm.get('posType').value !== 0) ? {'display': 'none'} : {}">
      <mb-drop-dow-list-lazy-search #formPositionCompTemp
        [params]='paramSearchPositionTemp' (mbEventSelectItem)='selectPositionTemp($event)'
        [accessDataSelect]="{name: 'name', id: 'id', dataRes: 'content'}"
        labelText="Positions" placeholderText="Position"
        [urlService]='urlPositionApi' [isDropDownList]="true">
      </mb-drop-dow-list-lazy-search>
    </div>

    <div nz-col nzXs="24" nzLg="8"
      [ngStyle]="setOfIndicatorForm.value['assignedType'] === 'HT' ? {'display': 'none'} : {}">
      <mb-drop-dow-list-lazy-search #formPositionComp
        [error]="isSubmitted && setOfIndicatorForm.controls['posId'].errors ? true : false"
        [params]='paramSearchPosition' (mbEventSelectItem)='selectPosition($event)'
        [accessDataSelect]="{name: 'name', id: 'id', dataRes: 'content'}"
        labelText="Tên position <span class='label__required'>*</span>" placeholderText="Tên position"
        [urlService]='urlPositionApi' [isDropDownList]="true">
      </mb-drop-dow-list-lazy-search>
      <div
        *ngIf="setOfIndicatorForm.controls['posId'].invalid && setOfIndicatorForm.controls['posId'].dirty && setOfIndicatorForm.controls['posId'].errors.required"
        class="color-error">
        <em nz-icon nzType="close-circle" nzTheme="outline"></em> Trường bắt buộc
      </div>
    </div>

    <div nz-col nzXs="24" nzLg="8">
      <mb-input-text formControlName="sotName" [mbShowFlexEnd]="false"
        [mbType]="isSubmitted && setOfIndicatorForm.controls['sotName'].errors ? 'error' : 'default'"
        [mbShowError]="isSubmitted &&  setOfIndicatorForm.controls['sotName'].errors !== null"
        [mbErrors]=" setOfIndicatorForm.controls['sotName'].errors" [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'Trường bắt buộc' },
        { errorName: 'maxlength', errorDescription: 'Không được vượt quá 200 ký tự'}]" mbPlaceholderText="Tên bộ"
        (mbBlur)="removeSpace('sotName')" mbLabelText="Tên bộ <span class='label__required'>*</span>">
      </mb-input-text>
    </div>

    <div nz-col nzXs="24" nzLg="8">
      <mb-input-text formControlName="sotCode" [mbShowFlexEnd]="false"
        [mbDisable]="((data && setOfIndicatorForm.get('sotCode').value) && !copy) ? true : false"
        [mbType]="isSubmitted &&  setOfIndicatorForm.controls['sotCode'].errors ? 'error' : 'default'"
        [mbShowError]="isSubmitted &&  setOfIndicatorForm.controls['sotCode'].errors !== null"
        [mbErrors]=" setOfIndicatorForm.controls['sotCode'].errors" [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'Trường bắt buộc' },
        { errorName: 'maxlength', errorDescription: 'Không được vượt quá 50 ký tự'}]" mbPlaceholderText="Mã bộ"
        (mbBlur)="removeSpace('sotCode')" mbLabelText="Mã bộ <span class='label__required'>*</span>">
      </mb-input-text>
    </div>

    <div nz-col nzXs="24" nzLg="8">
      <mb-select [mbDataSelects]="listStatus" mbKeyLabel="label" mbKeyValue="value" formControlName="flagStatus"
        [mbDisable]="setOfIndicatorForm.value['assignedType'] === 'HT'"
        [mbType]="isSubmitted && setOfIndicatorForm.controls['flagStatus'].errors ? 'error' : 'default'"
        [mbShowError]="isSubmitted && setOfIndicatorForm.controls['flagStatus'].errors !== null"
        [mbErrors]="setOfIndicatorForm.controls['flagStatus'].errors" [mbErrorDefs]="[
        { errorName: 'required', errorDescription: 'Trường bắt buộc'}]" mbPlaceholder="Trạng thái"
        mbLabelText="Trạng thái <span class='label__required'>*</span>">
      </mb-select>
    </div>

    <div *ngIf="setOfIndicatorForm.value['assignedType'] === 'HT'" nz-col nzXs="24" nzLg="8">
      <mb-input-text formControlName="scale" [mbShowFlexEnd]="false" mbInputType="number"
        [mbType]="isSubmitted && setOfIndicatorForm.controls['scale'].errors ? 'error' : 'default'"
        [mbShowError]=" isSubmitted && setOfIndicatorForm.controls['scale'].errors !== null"
        [mbErrors]=" setOfIndicatorForm.controls['scale'].errors" [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'Trường bắt buộc' }, {
        errorName: 'rangeNumber', errorDescription: 'Phải nằm trong khoảng từ 0 đến 1'}]" mbPlaceholderText="Trọng số"
        mbLabelText="Trọng số <span class='label__required'>*</span>">
      </mb-input-text>
    </div>

  </div>

</form>

<div style="margin-top: 22px;">
  <label style="color: #14142B; font-size: 18px; font-weight: bold;">
    Danh sách chỉ tiêu <span style="color: #ED2E7E">*</span>
  </label>
</div>

<div style="display: flex; align-items: flex-end; justify-content: center;">
  <form nz-form [formGroup]="formSelect">
    <div nz-row [nzGutter]="[30, 10]" style="width: 80rem;">
      <div nz-col nzXs="24" nzLg="16">
        <mb-drop-dow-list-lazy-search #formTargetComp [params]='paramSearchTarget'
                                      (mbEventSelectItem)='onModelChangeTarget($event)'
                                      [accessDataSelect]="{name: 'tarName', id: 'tarId', dataRes: 'content'}" placeholderText="Chỉ tiêu"
                                      [urlService]='urlTargetApi' [isDropDownList]="true" [multiple]="true">
        </mb-drop-dow-list-lazy-search>
      </div>
    </div>
  </form>
  <div *ngIf="(data && setOfIndicatorForm.get('sotCode').value) && !copy">
    <label nz-checkbox [(ngModel)]="checked">Cập nhật BCT đã được gán</label>
  </div>
</div>


<div nz-row style="margin: 5px 0 5px 0;">
  <div *ngFor="let data of dataSourceTarget; let i = index" nz-col>
    <div style="display: flex; align-items: center; margin-right: 20px;">
      <nz-tag class="custom-tag" nz-tooltip [nzTooltipTitle]="data.tarName" nzTooltipPlacement="bottomLeft">
        {{data.tarName}}
      </nz-tag>
      <em nz-icon nzType="close" class="custom-icon" nzTheme="outline" (click)="onDeleteTargetTag(data)"></em>
    </div>
  </div>
</div>
<div class="ant-table-content">
  <nz-table *ngIf="setOfIndicatorForm.value['assignedType'] === 'HT'" nzSize='small' #basicTableHT
    [nzPageSize]="dataSourceTarget?.length" [nzData]="dataSourceTarget"
    [nzScroll]="dataSourceTarget?.length > 0 ? { x: '500px', y: '500px' } : {}" [nzShowPagination]="false"
    nzTableLayout="fixed" [nzSize]="TABLE_SIZE">
    <thead>
      <tr>
        <th scope="col" nzLeft>Chỉ Tiêu</th>
        <th scope="col">Trọng số (%)</th>
        <th scope="col" *ngFor="let data of listConfigAll; let i = index">
          {{data.name}}
        </th>
        <th scope="col" nzWidth="50px" nzRight></th>
      </tr>
    </thead>
    <tbody>
      <ng-container *ngFor="let data of basicTableHT.data; let i = index">
        <tr>
          <td nzLeft>
            {{data.tarName}}
          </td>
          <td>
              <mb-input-text
                *ngIf="data.typeRule !== 1"
                [mbShowFlexEnd]="false"
                [mbType]="data.error ? 'error' : 'default'"
                mbInputType="number"
                [(ngModel)]="data.scale"
                (mbChange)="convertNumber($event,data)"
                minNumber="0"
            ></mb-input-text>
            <div *ngIf="data.error" class="color-error">
              <em nz-icon nzType="close-circle" nzTheme="outline"></em> {{data.error}}
            </div>
          </td>
          <td *ngFor="let periodConfig of data.estimatePeriodConfigs; let i = index">
              <mb-input-text
                [mbShowFlexEnd]="false"
                mbInputType="number"
                [(ngModel)]="periodConfig.estimateNum"
                minNumber="0"
            ></mb-input-text>
          </td>
          <td nzRight>
            <em (click)="onDeleteTargetTag(data)" nz-icon nzType="delete" nzTheme="outline"></em>
          </td>
        </tr>
        <ng-container *ngIf="data.subs && data.subs.length > 0">
          <ng-container *ngFor="let dv1 of data.subs; let i1 = index">
            <tr>
              <td class="tr-for-class">
                <ul>
                  <li>{{dv1.tarName}}</li>
                </ul>
              </td>
              <td>
                  <mb-input-text
                    *ngIf="data.typeRule !== '1' && dv1.typeRule !== '1'"
                    [mbShowFlexEnd]="false"
                    [mbType]="dv1.error ? 'error' : 'default'"
                    mbInputType="number"
                    [(ngModel)]="dv1.scale"
                    (mbChange)="convertNumber($event,dv1)"
                    minNumber="0"
                  ></mb-input-text>
                <div *ngIf="dv1.error" class="color-error">
                  <em nz-icon nzType="close-circle" nzTheme="outline"></em> {{dv1.error}}
                </div>
              </td>
              <td *ngFor="let periodConfig of dv1.estimatePeriodConfigs; let i = index">
                  <mb-input-text
                    [mbShowFlexEnd]="false"
                    mbInputType="number"
                    [(ngModel)]="periodConfig.estimateNum"
                    minNumber="0"
                  ></mb-input-text>
              </td>
              <td></td>
            </tr>
          </ng-container>
        </ng-container>
      </ng-container>
    </tbody>
  </nz-table>
  <nz-table class="data-table" *ngIf="setOfIndicatorForm.value['assignedType'] === 'QL'" style="margin-top: 22px;" #basicTableQL
    [nzPageSize]="dataSourceTarget?.length" [nzData]="dataSourceTarget"
    [nzScroll]="dataSourceTarget?.length > 0 ? { x: '500px', y: '500px' } : {}" [nzShowPagination]="false"
    nzTableLayout="fixed" [nzSize]="TABLE_SIZE">
    <thead>
      <tr>
        <th scope="col">Thẻ điểm</th>
        <th scope="col">Chỉ tiêu</th>
        <th scope="col">Cách tính</th>
        <th scope="col">Trọng số (%)</th>
        <th scope="col" nzWidth="50px" nzRight></th>
      </tr>
    </thead>
    <tbody>
      <ng-container *ngFor="let data of basicTableQL.data; let i = index">
        <tr>
          <td>{{data.scoreCardName}}</td>
          <td>{{data.tarName}}</td>
          <td>{{data.scoringRuleName}}</td>
          <td>
              <mb-input-text
                *ngIf="data.typeRule !== '1'"
                [mbShowFlexEnd]="false"
                [mbType]="data.error ? 'error' : 'default'"
                mbInputType="number"
                [(ngModel)]="data.scale"
                (mbChange)="convertNumber($event,data)"
                minNumber="0"
              ></mb-input-text>
            <div *ngIf="data.error" class="color-error">
              <em nz-icon nzType="close-circle" nzTheme="outline"></em> {{data.error}}
            </div>
          </td>
          <td nzRight>
            <em (click)="onDeleteTargetTag(data)" nz-icon nzType="delete" nzTheme="outline"></em>
          </td>
        </tr>
        <ng-container *ngIf="data.subs && data.subs.length > 0">
          <ng-container *ngFor="let dv1 of data.subs; let i1 = index">
            <tr>
              <td>{{dv1.scoreCardName}}</td>
              <td class="tr-for-class">
                <ul>
                  <li>{{dv1.tarName}}</li>
                </ul>
              </td>
              <td>{{dv1.scoringRuleName}}</td>
              <td>
                  <mb-input-text
                    *ngIf="data.typeRule !== '1' && dv1.typeRule !== '1'"
                    [mbShowFlexEnd]="false"
                    [mbType]="dv1.error ? 'error' : 'default'"
                    mbInputType="number"
                    [(ngModel)]="dv1.scale"
                    (mbChange)="convertNumber($event,dv1)"
                    minNumber="0"
                  ></mb-input-text>
                <div *ngIf="dv1.error" class="color-error">
                  <em nz-icon nzType="close-circle" nzTheme="outline"></em> {{dv1.error}}
                </div>
              </td>
              <td></td>
            </tr>
          </ng-container>
        </ng-container>
      </ng-container>
    </tbody>
  </nz-table>
</div>
